import javax.swing.*;
import java.text.*;

class point {
  protected int x,y;
  point() { x=y=0; }
  point(int xx, int yy) { // method overloading ; multiple constructor
    x=xx; y=yy;
  }
  int getx() { return x; }
  int gety() { return y; }
  void setpoint(int xx, int yy) { x=xx; y=yy; }
  protected void finalize() {
    System.out.println("Point finalizer:"+this);
  }
  public String toString() {
    return "["+getx()+","+gety()+"]";
  }
}
class circle extends point {
  protected int ra;
  circle(int xx, int yy, int rr) { 
    super(xx,yy); ra=rr;
  }
  circle(int xx, int yy) { // method overloading ; multiple constructor
    super(xx,yy); ra=25;
  }
  circle(int rr) { // method overloading ; multiple constructor
    super(); ra=rr;
  }
  circle() { // method overloading ; multiple constructor
    super(); ra=25;
  }
  void setpoint(int xx, int yy) { super.setpoint(xx,yy); }
  void setradius(int rr) { ra=rr; }
  public int getradius() { return ra; }
  public double area() { return Math.PI*ra*ra; }
  protected void finalize() {
    System.out.println("Circle finalizer:"+this);
    super.finalize();
  }
  public String toString() {
    return "center="+super.toString()+"; radius="+ra;
  }
}

class cylinder extends circle {
  protected double height;
  cylinder() { setHeight(0);}
  cylinder(double hh, int rr, int x, int y) {
    super(x,y,rr); setHeight(hh);
  }
  public void setHeight(double h) { height=h; }
  public double getHeight() { return height; }
  public double area() { return 2*super.area()+2*Math.PI*ra*height; }
  public double volume() { return super.area()*height; }
  protected void finalize() {
    System.out.println("Cylinder finalizer:"+this);
    super.finalize();
  }
  public String toString() {
    return super.toString()+"; height="+height;
  }
}

class ch09_6 {
  public static void main(String[] args) {
    JTextArea ta=new JTextArea("");
    String out="point inheritance test==>\n";
    DecimalFormat pp=new DecimalFormat("0.00");

    cylinder a1=new cylinder(5.7,3,12,23);
    circle a2=new circle(20,30,50); 
    point a3=new point(30,45);  

    out+="a1 cylinder -->"+a1.toString()+" area="+pp.format(a1.area())+" volume="+pp.format(a1.volume())+"\n";
    out+="a2 circle -->"+a2.toString()+" area="+pp.format(a2.area())+"\n";
    out+="a3 point -->"+a3.toString()+"\n";

    a1=null; a2=null; a3=null; System.gc();

    ta.setText(out);
    JOptionPane.showMessageDialog(null, ta,"Show_result", JOptionPane.PLAIN_MESSAGE);
    System.exit(0);      
  }
}
